<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLApiCombiner&lt; ALG_MESSAGE_TYPE &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classTIGLApiCombiner-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLApiCombiner&lt; ALG_MESSAGE_TYPE &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__interface__engine.html">Interface</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Pure combiner class for the TIGL engine.  
 <a href="classTIGLApiCombiner.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglApiCombiner_8hpp_source.html">tiglApiCombiner.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a2077cdeab13cdf1c3baa234080da70f4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2077cdeab13cdf1c3baa234080da70f4"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#a2077cdeab13cdf1c3baa234080da70f4">TIGLApiCombiner</a> ()</td></tr>
<tr class="memdesc:a2077cdeab13cdf1c3baa234080da70f4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Contsructor. <br /></td></tr>
<tr class="separator:a2077cdeab13cdf1c3baa234080da70f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a09dde79861ca7ce4fb21d45864c6177e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a09dde79861ca7ce4fb21d45864c6177e"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#a09dde79861ca7ce4fb21d45864c6177e">~TIGLApiCombiner</a> ()</td></tr>
<tr class="memdesc:a09dde79861ca7ce4fb21d45864c6177e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:a09dde79861ca7ce4fb21d45864c6177e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a30cf4df9966822688e2afbaef1e0d43d"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#a30cf4df9966822688e2afbaef1e0d43d">combineMessages</a> (MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a30cf4df9966822688e2afbaef1e0d43d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Core combine function for multiple messages.  <a href="#a30cf4df9966822688e2afbaef1e0d43d">More...</a><br /></td></tr>
<tr class="separator:a30cf4df9966822688e2afbaef1e0d43d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a671a991a81931abff92afcf2ff088e93"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#a671a991a81931abff92afcf2ff088e93">combineMessages</a> (ALG_MESSAGE_TYPE &amp;newMessage, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a671a991a81931abff92afcf2ff088e93"><td class="mdescLeft">&#160;</td><td class="mdescRight">core combine function from combining a single message.  <a href="#a671a991a81931abff92afcf2ff088e93">More...</a><br /></td></tr>
<tr class="separator:a671a991a81931abff92afcf2ff088e93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c639e11026eddf4cea7a3589c0c2dfd"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#a4c639e11026eddf4cea7a3589c0c2dfd">sumCombineMessages</a> (MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a4c639e11026eddf4cea7a3589c0c2dfd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sum combine function.  <a href="#a4c639e11026eddf4cea7a3589c0c2dfd">More...</a><br /></td></tr>
<tr class="separator:a4c639e11026eddf4cea7a3589c0c2dfd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab8ce5ce325271de34415b2b383772c7"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#aab8ce5ce325271de34415b2b383772c7">sumCombineMessages</a> (ALG_MESSAGE_TYPE &amp;newMessage, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:aab8ce5ce325271de34415b2b383772c7"><td class="mdescLeft">&#160;</td><td class="mdescRight">implementation of sum combine function for adding a single message.  <a href="#aab8ce5ce325271de34415b2b383772c7">More...</a><br /></td></tr>
<tr class="separator:aab8ce5ce325271de34415b2b383772c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac06d71844afe085c44cde1f15d7fe47b"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#ac06d71844afe085c44cde1f15d7fe47b">maxCombineMessages</a> (MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:ac06d71844afe085c44cde1f15d7fe47b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Maximum combine function.  <a href="#ac06d71844afe085c44cde1f15d7fe47b">More...</a><br /></td></tr>
<tr class="separator:ac06d71844afe085c44cde1f15d7fe47b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abf2cf34e736dd01ce02d637874e8d142"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#abf2cf34e736dd01ce02d637874e8d142">maxCombineMessages</a> (ALG_MESSAGE_TYPE &amp;newMessage, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:abf2cf34e736dd01ce02d637874e8d142"><td class="mdescLeft">&#160;</td><td class="mdescRight">Max combine function for adding a single message.  <a href="#abf2cf34e736dd01ce02d637874e8d142">More...</a><br /></td></tr>
<tr class="separator:abf2cf34e736dd01ce02d637874e8d142"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a34d57c2049fdd0b687e13555bc2bc78c"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#a34d57c2049fdd0b687e13555bc2bc78c">minCombineMessages</a> (MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a34d57c2049fdd0b687e13555bc2bc78c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Minimum combine function.  <a href="#a34d57c2049fdd0b687e13555bc2bc78c">More...</a><br /></td></tr>
<tr class="separator:a34d57c2049fdd0b687e13555bc2bc78c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab5a0cb65378c4a4adf4036533e9c7966"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#ab5a0cb65378c4a4adf4036533e9c7966">minCombineMessages</a> (ALG_MESSAGE_TYPE &amp;newMessage, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:ab5a0cb65378c4a4adf4036533e9c7966"><td class="mdescLeft">&#160;</td><td class="mdescRight">Minimum combine function for a single message.  <a href="#ab5a0cb65378c4a4adf4036533e9c7966">More...</a><br /></td></tr>
<tr class="separator:ab5a0cb65378c4a4adf4036533e9c7966"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afc2384d77b522727bc9e5c6bd32242c7"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiCombiner.html#afc2384d77b522727bc9e5c6bd32242c7">bypassCombineMessages</a> (MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:afc2384d77b522727bc9e5c6bd32242c7"><td class="mdescLeft">&#160;</td><td class="mdescRight">bypass combine function.  <a href="#afc2384d77b522727bc9e5c6bd32242c7">More...</a><br /></td></tr>
<tr class="separator:afc2384d77b522727bc9e5c6bd32242c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename ALG_MESSAGE_TYPE&gt;<br />
class TIGLApiCombiner&lt; ALG_MESSAGE_TYPE &gt;</h3>

<p>Pure combiner class for the TIGL engine. </p>
<p>It contains the definitions of the combine function and has few template implementations It is a template class that is parameterized by </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ALG_MESSAGE_TYPE</td><td>the data field of pregel messages </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="afc2384d77b522727bc9e5c6bd32242c7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiCombiner.html">TIGLApiCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::bypassCombineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>bypass combine function. </p>
<p>it copies the input to the output </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages. </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages (which equals numMessages). </dd></dl>

</div>
</div>
<a class="anchor" id="a30cf4df9966822688e2afbaef1e0d43d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiCombiner.html">TIGLApiCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::combineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Core combine function for multiple messages. </p>
<p>It is an empty function that must be overridden by customized vertex definition for the different graph algorithms. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages. </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages. </dd></dl>

</div>
</div>
<a class="anchor" id="a671a991a81931abff92afcf2ff088e93"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiCombiner.html">TIGLApiCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::combineMessages </td>
          <td>(</td>
          <td class="paramtype">ALG_MESSAGE_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>core combine function from combining a single message. </p>
<p>It is an empty function that must be overridden by customized vertex definition for the different graph algorithms. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>the new message. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of messages after combining. </dd></dl>

</div>
</div>
<a class="anchor" id="ac06d71844afe085c44cde1f15d7fe47b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiCombiner.html">TIGLApiCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::maxCombineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Maximum combine function. </p>
<p>It computes the maximum the data fields of all messages into a single message. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages. </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages (1 if there are messages, 0 if no messages). </dd></dl>

</div>
</div>
<a class="anchor" id="abf2cf34e736dd01ce02d637874e8d142"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiCombiner.html">TIGLApiCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::maxCombineMessages </td>
          <td>(</td>
          <td class="paramtype">ALG_MESSAGE_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Max combine function for adding a single message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the new message. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages. </dd></dl>

</div>
</div>
<a class="anchor" id="a34d57c2049fdd0b687e13555bc2bc78c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiCombiner.html">TIGLApiCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::minCombineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Minimum combine function. </p>
<p>it computes the minimum the data fields of all messages into a single message. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages. </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages (1 if there are messages, 0 if no messages). </dd></dl>

</div>
</div>
<a class="anchor" id="ab5a0cb65378c4a4adf4036533e9c7966"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiCombiner.html">TIGLApiCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::minCombineMessages </td>
          <td>(</td>
          <td class="paramtype">ALG_MESSAGE_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Minimum combine function for a single message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the new message. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4c639e11026eddf4cea7a3589c0c2dfd"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiCombiner.html">TIGLApiCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::sumCombineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sum combine function. </p>
<p>it sums the data fields of all messages into a single message </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages (1 if there are messages, 0 if no messages) </dd></dl>

</div>
</div>
<a class="anchor" id="aab8ce5ce325271de34415b2b383772c7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiCombiner.html">TIGLApiCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::sumCombineMessages </td>
          <td>(</td>
          <td class="paramtype">ALG_MESSAGE_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>implementation of sum combine function for adding a single message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the new message </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="tiglApiCombiner_8hpp_source.html">tiglApiCombiner.hpp</a></li>
<li><a class="el" href="tiglImplementationCombiner_8hpp_source.html">tiglImplementationCombiner.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:55 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
